import winim
import strutils
import strformat
import random
import os

randomize()

type sound* = ref object of RootObj
    sAlias: string
    iLength: int

method close*(this: sound): bool {.discardable, base.} = 
    if this.sAlias == "": return false
    result = mciSendStringW(fmt("close {this.sAlias}"), "", 0, 0) == 0
    this.sAlias = ""
    this.iLength = 0

method open*(this: sound, sFilename: string): bool {.discardable, base.} = 
    if this.sAlias != "": this.close()
    for i in 0..9:
        this.sAlias &= char(rand(65..90))
    if mciSendStringW(fmt("open \"{sFilename}\" alias {this.sAlias}"), "", 0, 0) != 0: return false
    mciSendStringW(fmt("set {this.sAlias} time format milliseconds"), "", 0, 0)
    var buf: array[255, WCHAR] 
    var lpszReturn: LPWSTR = buf.addr
    result = mciSendStringW(fmt("status {this.sAlias} length"), lpszReturn, 255, 0) == 0
    this.iLength = parseInt($lpszReturn)

method seek*(this: sound, iPos: int = 0): bool {.discardable, base.} = 
    if this.sAlias == "": return false
    return mciSendStringW(fmt("seek {this.sAlias} to ") & (if iPos > 0: $iPos else: "start"), "", 0, 0) == 0

method length*(this: sound): int {.base.} = return this.iLength

method pos*(this: sound): int {.base.} = 
    if this.sAlias == "": return -1
    var buf: array[255, WCHAR] 
    var lpszReturn: LPWSTR = buf.addr
    mciSendStringW(fmt("status {this.sAlias} position"), lpszReturn, 255, 0)
    result = parseInt($lpszReturn)

method play*(this: sound, bWait: bool = false): bool {.discardable, base.} = 
    if this.sAlias == "": return false
    if this.pos() >= this.iLength: this.seek()
    return mciSendStringW(fmt("play {this.sAlias}") & (if bWait: " wait" else: ""), "", 0, 0) == 0

method pause*(this: sound): bool {.discardable, base.} = 
    if this.sAlias == "": return false
    return mciSendStringW(fmt("pause {this.sAlias}"), "", 0, 0) == 0

method resume*(this: sound): bool {.discardable, base.} = 
    if this.sAlias == "": return false
    return mciSendStringW(fmt("resume {this.sAlias}"), "", 0, 0) == 0

method stop*(this: sound): bool {.discardable, base.} = 
    if this.sAlias == "": return false
    return mciSendStringW(fmt("stop {this.sAlias}"), "", 0, 0) == 0

method status*(this: sound): string {.base.} =
    if this.sAlias == "": return "no alias"
    var buf: array[255, WCHAR] 
    var lpszReturn: LPWSTR = buf.addr
    mciSendStringW(fmt("status {this.sAlias} mode"), lpszReturn, 255, 0)
    return $lpszReturn

method setVolume*(this: sound, iVolume: int): bool {.discardable, base.} = 
    if this.sAlias == "" or iVolume < 0 or iVolume > 1000: return false
    return mciSendStringW(fmt("setaudio {this.sAlias} volume to {iVolume}"), "", 0, 0) == 0

proc ticksToTime*(iTicks: int): string =
    if iTicks < 0: return "error"
    var h, m, s: int
    s = int(iTicks / 1000)
    h = int(s / 3600)
    s = s mod 3600
    m = int(s / 60)
    s = s mod 60
    if h > 99:
        result = fmt("{h:0>3}:{m:0>2}:{s:0>2}")
    elif h > 0:
        result = fmt("{h:0>2}:{m:0>2}:{s:0>2}")
    else:
        result = fmt("{m:0>2}:{s:0>2}")
